/*
	Copyright (C) 2004-2005 Cory Nelson

	This software is provided 'as-is', without any express or implied
	warranty.  In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	1. The origin of this software must not be misrepresented; you must not
		claim that you wrote the original software. If you use this software
		in a product, an acknowledgment in the product documentation would be
		appreciated but is not required.
	2. Altered source versions must be plainly marked as such, and must not be
		misrepresented as being the original software.
	3. This notice may not be removed or altered from any source distribution.
	
	CVS Info :
		$Author: phrostbyte $
		$Date: 2005/05/09 23:14:42 $
		$Revision: 1.6 $
*/

#include "stdafx.h"
using namespace std;

std::wstring mbstowcs(const std::string &str) {
	size_t len=mbstowcs(NULL, str.c_str(), str.length());
	boost::scoped_array<wchar_t> buf(new wchar_t[len]);

	len=mbstowcs(buf.get(), str.c_str(), str.length());
	if(len==static_cast<size_t>(-1)) throw mbs_error("mbstowcs(): invalid multi-byte character");

	return wstring(buf.get(), len);
}

std::string wcstombs(const std::wstring &str) {
	size_t len=wcstombs(NULL, str.c_str(), 0);
	boost::scoped_array<char> buf(new char[len]);

	len=wcstombs(buf.get(), str.c_str(), len);
	if(len==static_cast<size_t>(-1)) throw mbs_error("wcstombs(): unable to convert character");

	return string(buf.get(), len);
}
