/*
	Copyright (C) 2004-2005 Cory Nelson

	This software is provided 'as-is', without any express or implied
	warranty.  In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	1. The origin of this software must not be misrepresented; you must not
		claim that you wrote the original software. If you use this software
		in a product, an acknowledgment in the product documentation would be
		appreciated but is not required.
	2. Altered source versions must be plainly marked as such, and must not be
		misrepresented as being the original software.
	3. This notice may not be removed or altered from any source distribution.
	
	CVS Info :
		$Author: phrostbyte $
		$Date: 2005/05/18 00:51:03 $
		$Revision: 1.3 $
*/

#ifndef __DRIVER_H__
#define __DRIVER_H__

#include <stdexcept>
#include <windows.h>
#include "tstring.h"
#include "win32_error.h"

class driver_error : public win32_error {
public:
	driver_error(const char *func) : win32_error(func) {}
};

class Driver {
private:
	HANDLE dev;
	tstring name, file, devfile;
	bool loaded, started;

public:
	bool removable;

	Driver();
	~Driver();

	void Load(const tstring &name);
	void Load(const tstring &name, const tstring &file);
	void Load(const tstring &name, const tstring &file, const tstring &devfile);
	void Close();

	void Start();
	void Stop();

	bool RawIo(DWORD ioctl, LPVOID inbuf, DWORD insize, LPVOID outbuf, DWORD outsize, LPOVERLAPPED overlapped=NULL);
	bool Read(DWORD ioctl, LPVOID buf, DWORD size, LPOVERLAPPED overlapped=NULL);
	bool Write(DWORD ioctl, LPVOID buf, DWORD size, LPOVERLAPPED overlapped=NULL);
};

#endif
