/*
	Copyright (C) 2004-2005 Cory Nelson

	This software is provided 'as-is', without any express or implied
	warranty.  In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	1. The origin of this software must not be misrepresented; you must not
		claim that you wrote the original software. If you use this software
		in a product, an acknowledgment in the product documentation would be
		appreciated but is not required.
	2. Altered source versions must be plainly marked as such, and must not be
		misrepresented as being the original software.
	3. This notice may not be removed or altered from any source distribution.
	
	CVS Info :
		$Author: phrostbyte $
		$Date: 2005/02/26 05:14:20 $
		$Revision: 1.2 $
*/

#ifndef __WIN32_ERROR_H__
#define __WIN32_ERROR_H__

#include <string>
#include <stdexcept>
#include <windows.h>

class win32_error : public std::runtime_error {
private:
	static std::string lasterror() {
		unsigned long err=GetLastError();
		char *buf;

		int len=FormatMessageA(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM, NULL, err, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPSTR)&buf, 0, NULL);

		std::string ret(buf, len);
		LocalFree(buf);
		return ret;
	}

	static std::string format(const std::string &func) {
		return func+": "+lasterror();
	}

public:
	win32_error(const std::string &func) : runtime_error(format(func)) {}
};

#endif
