/*
	Copyright (C) 2004-2005 Cory Nelson
	Based on the original work by Tim Leonard

	This software is provided 'as-is', without any express or implied
	warranty.  In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	1. The origin of this software must not be misrepresented; you must not
		claim that you wrote the original software. If you use this software
		in a product, an acknowledgment in the product documentation would be
		appreciated but is not required.
	2. Altered source versions must be plainly marked as such, and must not be
		misrepresented as being the original software.
	3. This notice may not be removed or altered from any source distribution.
	
	CVS Info :
		$Author: phrostbyte $
		$Date: 2005/03/01 02:18:53 $
		$Revision: 1.3 $
*/

#ifndef __FILTER_H__
#define __FILTER_H__

//
// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-0x7FFF(32767), and 0x8000(32768)-0xFFFF(65535)
// are reserved for use by customers.
//
#define FILE_DEVICE_PEERGUARDIAN  0xBEEF

//
// Macro definition for defining IOCTL and FSCTL function control codes. Note
// that function codes 0-0x7FF(2047) are reserved for Microsoft Corporation,
// and 0x800(2048)-0xFFF(4095) are reserved for customers.
//
#define PEERGUARDIAN_IOCTL_BASE  0xDED

//
// The device driver IOCTLs
//
#define CTL_CODE_PEERGUARDIAN(i,a) CTL_CODE(FILE_DEVICE_PEERGUARDIAN, PEERGUARDIAN_IOCTL_BASE+(i), METHOD_BUFFERED, (a))

#define IOCTL_PEERGUARDIAN_HOOK						CTL_CODE_PEERGUARDIAN(0,FILE_WRITE_DATA)
#define IOCTL_PEERGUARDIAN_SETRANGES				CTL_CODE_PEERGUARDIAN(1,FILE_WRITE_DATA)
#define IOCTL_PEERGUARDIAN_HTTP						CTL_CODE_PEERGUARDIAN(2,FILE_WRITE_DATA)
#define IOCTL_PEERGUARDIAN_GETNOTIFICATION		CTL_CODE_PEERGUARDIAN(3,FILE_READ_DATA)

//
// Name that Win32 front end will use to open the PeerDefender device
//
#define PEERGUARDIAN_DEVICE_NAME_WIN32	_T("\\\\.\\pgfilter")

typedef struct _pg_iprange {
	LPCWSTR name;	// not stored in driver, make sure pointer is constant
	ULONG start;
	ULONG end;
} PGIPRANGE;

typedef struct _pg_notification {
	LPCWSTR name;
	ULONG source;
	USHORT sourceport;
	ULONG destination;
	USHORT destinationport;
	UCHAR protocol;
	UCHAR blocked;
} PGNOTIFICATION;

#endif
