/*
	Copyright (C) 2004-2005 Cory Nelson
	Based on the original work by Tim Leonard

	This software is provided 'as-is', without any express or implied
	warranty.  In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:

	1. The origin of this software must not be misrepresented; you must not
		claim that you wrote the original software. If you use this software
		in a product, an acknowledgment in the product documentation would be
		appreciated but is not required.
	2. Altered source versions must be plainly marked as such, and must not be
		misrepresented as being the original software.
	3. This notice may not be removed or altered from any source distribution.
	
	CVS Info :
		$Author: phrostbyte $
		$Date: 2005/03/01 02:18:53 $
		$Revision: 1.3 $
*/

#ifndef __INTERNAL_H__
#define __INTERNAL_H__

#include "filter.h"
#include "notificationqueue.h"

#define NT_DEVICE_NAME L"\\Device\\pgfilter"
#define DOS_DEVICE_NAME L"\\DosDevices\\pgfilter"

#define HTONL(l) (\
	(((l)&0xff000000) >> 24) | \
	(((l)&0x00ff0000) >> 8) | \
	(((l)&0x0000ff00) << 8) | \
	(((l)&0x000000ff) << 24) \
)
#define NTOHL(l) HTONL(l)

#define HTONS(s) (\
	(((s)&0xff00) >> 8) | \
	(((s)&0x00ff) << 8) \
)
#define NTOHS(s) HTONS(s)

#pragma pack(1)
typedef struct __ip_header {
	UCHAR		iphVerLen;		// Version and length 
	UCHAR		ipTOS;			// Type of service 
	USHORT	ipLength;		// Total datagram length 
	USHORT	ipID;				// Identification 
	USHORT	ipFlags;			// Flags
	UCHAR		ipTTL;			// Time to live 
	UCHAR		ipProtocol;		// Protocol 
	USHORT	ipChecksum;		// Header checksum 
	ULONG		ipSource;		// Source address 
	ULONG		ipDestination;	// Destination address 
} IP_HEADER;

typedef struct __tcp_header {
	USHORT	sourcePort;
	USHORT	destinationPort;
	ULONG		sequence;
	ULONG		ack;
} TCP_HEADER, UDP_HEADER;
#pragma pack()

typedef struct __pg_internal {
	NOTIFICATION_QUEUE queue;

	KSPIN_LOCK rangeslock;

	PGIPRANGE *blockedranges;
	ULONG blockedcount;

	int blockhttp;
} PGINTERNAL;

#endif
